
// _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/ //
// _/													 _/	//
// _/ Falling Pieces Copyright (c) 2011 Yuichiro Itohara _/	//
// _/													 _/	//
// _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/ //

#include <windows.h>	
#include "DxLib.h"		

// O[oϐ ------------------------------------------------------------------------------ //
int winMode = 1;								// EBhE[hi1:EBhE, 0:tXN[j
int exitFlag = 0;								// \tgIʂtO
int frame = 0;									// t[i\tgJñt[JEgj
struct grData { int font20; int font24; int font64; int BG[5]; int cursor; int PieceT; int Controller; int KeyBoard; int CameraIcon; };
struct grData grp = { 0 };						// 摜f[^
struct seData { int seCursor; int seDecide; int seCancel; int seStart; int seTurn; int seHold; int seSolid; int seErase; int sePEPO; int seOver; };
struct seData se = { 0 };						// ʉf[^
int Key[256];									// L[i͂̎ʂj
enum eScreenMode { _TITLE, _OPTION, _CONTROLL, _SELECT, _MAIN_GAME, _PAUSE, _ENDING, _GAME_OVER };		// ʃ[h	
int scene = _TITLE;								// V[ỉ݂ʃ[hʂj		
int cameraMode = 0;								// J[hi1:JON, 0:JOFFj
int gridMode = 1;								// Obh[hi1:ObhON, 0:ObhOFFj
enum eSHAPE { SH_NONE, SH_I, SH_O, SH_S, SH_Z, SH_J, SH_L, SH_T };							// VFCvieg~m̌`j
const int PIECE_SIZE = 24;						// s[X̃TCY
const int FIELD_WIDTH = 10;						// tB[h̕
const int FIELD_HEIGHT = 20;					// tB[h̍
int field[FIELD_WIDTH][FIELD_HEIGHT] = { 0 };	// tB[hiQ[̗L̈j
int Piece[5][5] = { 0 };						// s[X
int PieceX = 0, PieceY = 0;						// s[Ẍʒu
int ghostPiece[5][5] = { 0 };					// S[Xgs[X
int ghostPieceX = 0, ghostPieceY = 0;			// S[Xgs[Ẍʒu
int nextPiece[3][5][5] = { 0 };					// lNXgs[Xi~Rj
int holdPiece[5][5] = { 0 };					// z[hs[X
int holdFrag = false;							// z[hʂtO
int music = 1;									// ~[WbNitBGMʂj
int score = 0;									// XRAiQ[Ɋl_̑vj
int bestScore = 0;								// xXgXRAiQ[NɏoōXRAj
int level = 1;									// xieg~m̗xAXRAɂej
int line = 0;									// CiQ[ɏ̑vj
int chain = 0;									// `FCiS̘Aj
int fixTime = 0;								// Œ莞ԁis[Xڒn̍ۂ̗Vюԁj
int fixingTime = 30;							// Œ莞ԁi萔j
int getScore[7] = { 0, 40, 120, 400, 1200, -20, 400 };	// XRAvZp 0-4:C, 5:z[h, 6:`FC{[iX

// ֐vg^Cv ---------------------------------------------------------------------------- //
void InitGrp( void );		//
void InitSE( void );		//
void FullScreen( void );	//
void Input( void );			//
void Title( void );			// ʃ[hF^Cg
void Option( void );		// ʃ[hFIvV
void Controll( void );		// ʃ[hFRg[
void DrawMenu( int x, int y, int h, int menu, char* str[6] );
void PlayMusicGame( void );	
void Select( void );		// ʃ[hFZNg
void MainGame( void );		// ʃ[hFCQ[
void Pause( void );			// ʃ[hF|[Y
void Ending( void );		// ʃ[hFGfBO
void GameOver( void );		// ʃ[hFQ[I[o[
void changeCameraMode( void );
void changeGridMode( void );
int GetTopSide( void );			// iCQ[j
int GetDownSide( void );		//
int GetLeftSide( void );		//
int GetRightSide( void );		//
bool MoveDown( void );			//
bool MoveLeft( void );			//
bool MoveRight( void );			//
bool TurnPiece( int turn = 0 );	//
int HoldPiece( void );			//
void GhostBlock( void );		//
void HardDrop( void );			//
void FixPiece( void );			//
int AdjustLine( void );			//
void AppearPiece( void );		//
void DrawScore( void );												// `iCQ[j
void DrawNext( float X, float Y, float Z );							//
void DrawHold( float X, float Y, float Z );							//
void DrawField( float X, float Y, float Z );						//
void DrawPieceNone( int piece, float X1, float Y1, float Z1 );		//
void DrawPieceGhost( int piece, float X1, float Y1, float Z1 );		//
void DrawPieceSide( int piece, float X1, float Y1, float Z1 );		//
void DrawPieceTop( int piece, float X1, float Y1, float Z1 );		//
void DrawPieceFront( int piece, float X1, float Y1, float Z1 );		//
void SetPieceColor( int piece, int& Color1, int& Color2 );			//

// EBC֐ ---------------------------------------------------------------------------- //
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	// 
	SetGraphMode( 640 , 480 , 16 );					// ʃ[h̃Zbg
	SetOutApplicationLogValidFlag(false);			// Log.txt̏o͂}
	SetWindowIconID( 101 );							// ^CgACR̕ύX
	SetMainWindowText( "Falling Pieces 1.22" );		// ^Cgo[̕ύX
	ChangeWindowMode( winMode );					// EBhE[hŋN
	if( DxLib_Init() == -1 ) { return -1; }			// cwCu
	InitGrp();										// 摜f[^̃[h
	InitSE();										// ʉf[^̃[h
	PlayMusicGame();
	// C[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 && exitFlag == 0 ) {	
		frame ++ ;			// t[Z
		Input();			// ͂̊m
		ClearDrawScreen();	// ʂNA
		if ( Key[KEY_INPUT_TAB] == 1 ) { FullScreen(); }
		// ʃ[h
		switch ( scene ) {
		case _TITLE:		Title();	break;
		case _OPTION:		Option();	break;
		case _CONTROLL:		Controll();	break;
		case _SELECT:		Select();	break;
		case _MAIN_GAME:	MainGame();	break;
		case _PAUSE:		Pause();	break;
		case _GAME_OVER:	GameOver();	break;
		case _ENDING:		Ending();	break;
		}
		ScreenFlip();		// ʂ̓e\ʂɔfiPC̃t[[gɍ킹ĕ`悳j
	}
	DxLib_End();			// cwCugp̏I
	return 0 ;				// \tg̏I
}

// 摜̏iEBhETCYύXۂɂK{j------------------------------------- //
void InitGrp( void )
{	
	SetDrawScreen( DX_SCREEN_BACK );					// `ʂ𗠉ʂɃZbg
	grp.font20 = CreateFontToHandle( NULL, 20, -1, DX_FONTTYPE_ANTIALIASING_EDGE );	// tHgݒ
	grp.font24 = CreateFontToHandle( NULL, 24, -1, DX_FONTTYPE_ANTIALIASING_EDGE );	// 
	grp.font64 = CreateFontToHandle( NULL, 64, -1, DX_FONTTYPE_ANTIALIASING_EDGE );	// 
	grp.BG[0] = LoadGraph( "Data/Graphic/bg00.jpg" );				// 摜f[^ǂݍ 
	grp.BG[1] = LoadGraph( "Data/Graphic/bg01.jpg" );				// 
	grp.BG[2] = LoadGraph( "Data/Graphic/bg02.jpg" );				// 
	grp.BG[3] = LoadGraph( "Data/Graphic/bg03.jpg" );				//
	grp.BG[4] = LoadGraph( "Data/Graphic/bg04.jpg" );				//
	grp.cursor = LoadGraph( "Data/Graphic/cursor.png" );			//	
	grp.PieceT = LoadGraph( "Data/Graphic/pieceT.png" );			//
	grp.Controller = LoadGraph( "Data/Graphic/controller.png" );	//
	grp.KeyBoard = LoadGraph( "Data/Graphic/keyBoard.png" );		//
	grp.CameraIcon = LoadGraph( "Data/Graphic/cameraIcon.jpg" );	//
}

// ʉ̏ -------------------------------------------------------------------------- //
void InitSE( void )
{
	se.seCursor = LoadSoundMem( "Data/Sound/cursor.wav" );	// ʉf[^ǂݍ
	se.seDecide = LoadSoundMem( "Data/Sound/decide.wav" );	//
	se.seCancel = LoadSoundMem( "Data/Sound/cancel.wav" );	//
	se.seStart = LoadSoundMem( "Data/Sound/start.wav" );		//
	se.seTurn = LoadSoundMem( "Data/Sound/po2.wav" );			//
	se.seHold = LoadSoundMem( "Data/Sound/gasa.wav" );		//
	se.seSolid = LoadSoundMem( "Data/Sound/bachi.wav" );		//
	se.seErase = LoadSoundMem( "Data/Sound/chu1.wav" );		//
	se.sePEPO = LoadSoundMem( "Data/Sound/pikoon.wav" );		//
	se.seOver = LoadSoundMem( "Data/Sound/GameOver.wav" );	//
}

// Q[̉yĐ -------------------------------------------------------------------------- //
void PlayMusicGame( void )
{
	switch( scene ) {
	case _TITLE:	PlayMusic( "Data/Sound/fantasy01.mid", DX_PLAYTYPE_LOOP );	break;
	case _SELECT:
	case _MAIN_GAME:
		if ( music == 0 ) { StopMusic(); }
		if ( music == 1 ) { PlayMusic( "Data/Sound/fantasy04.mid", DX_PLAYTYPE_LOOP ); }
		if ( music == 2 ) { PlayMusic( "Data/Sound/up01.mid", DX_PLAYTYPE_LOOP );  } 
		if ( music == 3 ) { PlayMusic( "Data/Sound/A.mid", DX_PLAYTYPE_LOOP ); } 
		break;
	case _GAME_OVER: PlayMusic( "Data/Sound/orc02.mid", DX_PLAYTYPE_LOOP );	break;
	case _ENDING:	PlayMusic( "Data/Sound/A'.mid", DX_PLAYTYPE_LOOP );	break;
	}
}

// tXN[̐؂ւ -------------------------------------------------------------------- //
void FullScreen( void )
{	
	if ( winMode == 1 ) winMode = 0;
	else winMode = 1;
	ChangeWindowMode( winMode );
	InitGrp();
}

// Q[pbhAL[{[h̓͏Ԃ̍XV ---------------------------------------------------- //
void Input( void )
{	
	int padInput = GetJoypadInputState( DX_INPUT_PAD1 );
	char keyBuff[256];
	GetHitKeyStateAll( keyBuff );
	// L[A{^
	if ( ( padInput & PAD_INPUT_LEFT ) || keyBuff[KEY_INPUT_LEFT] ) { Key[KEY_INPUT_LEFT] ++; }
	else { Key[KEY_INPUT_LEFT] = 0; }
	// L[A{^
	if ( ( padInput & PAD_INPUT_UP ) || keyBuff[KEY_INPUT_UP] ) { Key[KEY_INPUT_UP] ++; }
	else { Key[KEY_INPUT_UP] = 0; }
	// L[A{^
	if ( ( padInput & PAD_INPUT_RIGHT ) || keyBuff[KEY_INPUT_RIGHT] ) { Key[KEY_INPUT_RIGHT] ++; }
	else { Key[KEY_INPUT_RIGHT] = 0; }
	// L[A{^
	if ( ( padInput & PAD_INPUT_DOWN ) || keyBuff[KEY_INPUT_DOWN] ) { Key[KEY_INPUT_DOWN] ++; }
	else { Key[KEY_INPUT_DOWN] = 0; }
	// ZL[A{^
	if ( ( padInput & PAD_INPUT_C ) || keyBuff[KEY_INPUT_Z] ) { Key[KEY_INPUT_Z] ++; }
	else { Key[KEY_INPUT_Z] = 0; }
	// XL[ABkSpL[A~{^
	if ( ( padInput & PAD_INPUT_B ) || keyBuff[KEY_INPUT_X] || keyBuff[KEY_INPUT_BACK] ) { Key[KEY_INPUT_X] ++; }
	else { Key[KEY_INPUT_X] = 0; }
	// CL[, {^igpj
	if ( ( padInput & PAD_INPUT_X ) || keyBuff[KEY_INPUT_C] ) { Key[KEY_INPUT_C] ++; }	
	else { Key[KEY_INPUT_C] = 0; }
	// spaceL[AL{^
	if ( ( padInput & PAD_INPUT_L ) || keyBuff[KEY_INPUT_SPACE] ) { Key[KEY_INPUT_SPACE] ++; }
	else { Key[KEY_INPUT_SPACE] = 0; }
	// LShiftL[AR{^
	if ( ( padInput & PAD_INPUT_R ) || keyBuff[KEY_INPUT_LSHIFT] ) { Key[KEY_INPUT_LSHIFT] ++; }
	else { Key[KEY_INPUT_LSHIFT] = 0; }
	// EnterL[ASTART{^
	if ( ( padInput & PAD_INPUT_START ) || keyBuff[KEY_INPUT_RETURN] ) { Key[KEY_INPUT_RETURN] ++; }
	else { Key[KEY_INPUT_RETURN] = 0; }
	// TabL[ : tXN[
	if ( keyBuff[KEY_INPUT_TAB] ) { Key[KEY_INPUT_TAB] ++; }
	else { Key[KEY_INPUT_TAB] = 0; }
	// GL[ : Obh[h
	if ( keyBuff[KEY_INPUT_G] ) { Key[KEY_INPUT_G] ++; }
	else { Key[KEY_INPUT_G] = 0; }
}

// ^Cg -------------------------------------------------------------------------------- //
void Title( void )	
{
	enum eTitle { _START, _MENU, _OPTION };
	static eTitle titleScene = _START;
	// ^Cgʕ`
	DrawGraph( 0, 0, grp.BG[2], false );
	static int color3D[3] = {0};
	if ( frame % 2 == 0 && titleScene == _TITLE ) { for ( int i=0; i<3; i++ ) { color3D[i] = GetRand(96) + 64; } }
	int color[7] = {
		GetColor( color3D[0], color3D[1], color3D[2] ),
		GetColor( 100, 150, 150 ),
		GetColor( 150, 100, 150 ),
		GetColor( 150, 150, 100 ),
		GetColor( 150, 100, 100 ),
		GetColor( 100, 150, 100 ),
		GetColor( 100, 100, 150 )
	};
	int x = 160, y = 50;
	DrawStringToHandle( x+3, y+3, "Falling", color[0], grp.font64 );
	DrawStringToHandle( x, y, "F", color[1], grp.font64 );
	DrawStringToHandle( x, y, " a", color[2], grp.font64 );
	DrawStringToHandle( x, y, "  l", color[3], grp.font64 );
	DrawStringToHandle( x, y, "   l", color[4], grp.font64 );
	DrawStringToHandle( x, y, "    i", color[5], grp.font64 );
	DrawStringToHandle( x, y, "     n", color[6], grp.font64 );
	DrawStringToHandle( x, y, "      g", color[1], grp.font64 );
	x += 50, y += 60;
	DrawStringToHandle( x+3, y+3, "Pieces", color[0], grp.font64 );
	DrawStringToHandle( x, y, "P", color[1], grp.font64 );
	DrawStringToHandle( x, y, " i", color[2], grp.font64 );
	DrawStringToHandle( x, y, "  e", color[3], grp.font64 );
	DrawStringToHandle( x, y, "   c", color[4], grp.font64 );
	DrawStringToHandle( x, y, "    e", color[5], grp.font64 );
	DrawStringToHandle( x, y, "     s", color[6], grp.font64 );
	DrawGraph( 420, 40, grp.PieceT, true );
	DrawStringToHandle( 160, 440, "copy right (c) 2011 Y.I", GetColor( 200, 200, 200 ), grp.font20 );

	static int menu = 0;
	// ^CgFX^[g
	if ( titleScene == _START ) {
		// ZL[F
		if( Key[KEY_INPUT_Z] == 1 ) {
			PlaySoundMem( se.sePEPO, DX_PLAYTYPE_NORMAL );
			titleScene = _MENU;
		}
		// `
		if ( frame%24 < 16 ) { 
			DrawStringToHandle( 208, 278, "PUSH Z BUTTON !", GetColor( 200, 200, 200 ), grp.font24 );
			DrawStringToHandle( 210, 280, "PUSH Z BUTTON !", GetColor( 100, 100, 100 ), grp.font24 );
		}
	}
	// ^CgFj[
	else if ( titleScene == _MENU ) {
		// ZL[F
		if( Key[KEY_INPUT_Z] == 1 ) {
			PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
			if ( menu == 0 ) { scene = _SELECT; PlayMusicGame(); }
			if ( menu == 1 ) { titleScene = _OPTION; menu = 0; }
			if ( menu == 2 ) { exitFlag = 1; }
		}
		// L[Fj[ړ
		if( Key[KEY_INPUT_DOWN] == 1 ) {	PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu++; if(menu>2) menu=0; 	}
		if( Key[KEY_INPUT_UP] == 1 ) {		PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu--; if(menu<0) menu=2; 	}
		// `
		static char* strMenu[6] = { "MAIN GAME", "OPTION", "EXIT" };
		DrawMenu( 250, 220, 40, menu, strMenu );
	}
	// ^CgFIvV
	else if ( titleScene == _OPTION ) {
		// ZL[F
		if( Key[KEY_INPUT_Z] == 1 ) {	
			PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
			if ( menu == 0 ) { FullScreen(); }
			if ( menu == 1 ) { scene = _CONTROLL; menu = 0; }
			if ( menu == 2 ) { titleScene = _MENU; menu = 0; }
		}
		// XL[FLZ
		if( Key[KEY_INPUT_X] == 1 ) {	
			PlaySoundMem( se.seCancel, DX_PLAYTYPE_BACK );
			titleScene = _MENU; menu = 0; 
		}
		// L[Fj[ړ
		if( Key[KEY_INPUT_DOWN] == 1 ) {	PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu++; if(menu>2) menu=0; 	}
		if( Key[KEY_INPUT_UP] == 1 ) { 		PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu--; if(menu<0) menu=2; 	}
		// `
		static char* strOption[6] = { "WINDOW MODE","CONTROLL", "BACK" };
		DrawMenu( 250, 220, 40, menu, strOption );
	}
}

// IvV ---------------------------------------------------------------------------------- //
void Option( void ) {}

// ʃ[hFRg[ -------------------------------------------------------------------- //
void Controll( void )
{
	static int menu = 0;
	static bool isJoyPad = false;
	// ZL[F
	if( Key[KEY_INPUT_Z] == 1 ) {
		PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
		if ( menu == 0 ) { isJoyPad = false; }
		if ( menu == 1 ) { isJoyPad = true; }
		if ( menu == 2 ) { scene = _TITLE; menu = 0; }
	}
	// XL[FLZ
	if( Key[KEY_INPUT_X] == 1 ) { 
		PlaySoundMem( se.seCancel, DX_PLAYTYPE_BACK );
		scene = _TITLE; menu = 0; 
	}
	// L[Fj[ړ
	if( Key[KEY_INPUT_DOWN] == 1 ) {	PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu++; if(menu>2) menu=0; 	}
	if( Key[KEY_INPUT_UP] == 1 ) { 		PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu--; if(menu<0) menu=2; 	}
	// `
	DrawGraph( 0, 0, grp.BG[4], false );
	if ( isJoyPad ) DrawGraph( 0, 0, grp.Controller, true );
	else DrawGraph( 0, 0, grp.KeyBoard, true );
	static char* strOption[6] = { "KEY BOARD", "JOY PAD", "BACK" };
	DrawMenu( 100, 30, 40, menu, strOption );
}

// `Fj[ ------------------------------------------------------------------------------ //
void DrawMenu( int x, int y, int h, int menu, char* str[6] )
{
	int rgb = 0;
	int colorS = GetColor( 200, 200, 200 );
	int colorD = GetColor( 100, 100, 100 );
	int color[6] = { colorD, colorD, colorD, colorD, colorD, colorD };
	static int colorM = 0;
	if ( frame % 2 == 0 ) { rgb = GetRand(64)+ 64; colorM = GetColor( rgb, rgb, rgb ); }
	color[menu] = colorM;
	for ( int i=0; i<6; i++ ) {
		DrawStringToHandle( x - 2, y + h * i - 2, str[i], colorS, grp.font24 );
		DrawStringToHandle( x, y+h*i, str[i], color[i], grp.font24 );
	}
	// J[\
	int move = -40;
	if ( frame % 40 < 20 ) { move += frame % 40 / 4; }
	else { move -= frame % 40 / 4 - 10; }
	DrawGraph( x + move, y + h * menu, grp.cursor, true );
}

// ZNg -------------------------------------------------------------------------------- //
void Select( void )
{
	static int menu = 0;
	// ZL[F
	if( Key[KEY_INPUT_Z] == 1 ) {	
		PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
		if ( menu == 0 ) { scene = _MAIN_GAME; for( int i=0; i<4; ++i ) { AppearPiece(); } PlaySoundMem( se.seStart, DX_PLAYTYPE_BACK ); }
		if ( menu == 1 ) { level++; if( level > 9 ) level = 1; }
		if ( menu == 2 ) { music++;	if( music > 3 ) { music = 0; } PlayMusicGame(); }
		if ( menu == 3 ) { changeCameraMode(); }
		if ( menu == 4 ) { changeGridMode(); }
		if ( menu == 5 ) { scene = _TITLE; PlayMusicGame(); }
	}
	// XL[FLZ
	if( Key[KEY_INPUT_X] == 1 ) {
		PlaySoundMem( se.seCancel, DX_PLAYTYPE_BACK );
		scene = _TITLE; PlayMusicGame();
	}
	// L[Fj[ړ
	if( Key[KEY_INPUT_DOWN] == 1 ) {	PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu++; if(menu>5) menu = 0; }
	else if( Key[KEY_INPUT_UP] == 1 ) { PlaySoundMem( se.seCursor, DX_PLAYTYPE_BACK );	menu--; if(menu<0) menu = 5; }
	// L[FڕύX
	if( Key[KEY_INPUT_LEFT] == 1 ) {
		if( menu >= 1 && menu <= 4 ) PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
		if( menu == 1 ) { level--; if( level < 1 ) level = 9; } 
		if( menu == 2 ) { music--; if( music < 0 ) music = 3; PlayMusicGame(); }
		if( menu == 3 ) { changeCameraMode(); }
		if( menu == 4 ) { changeGridMode(); }
	}
	else if( Key[KEY_INPUT_RIGHT] == 1 ) { 
		if( menu >= 1 && menu <= 4 ) PlaySoundMem( se.seDecide, DX_PLAYTYPE_BACK );
		if( menu == 1 ) { level++; if( level > 9 ) level = 1; }
		if( menu == 2 ) { music++; if( music > 3 ) music = 0; PlayMusicGame(); }
		if( menu == 3 ) { changeCameraMode(); }
		if( menu == 4 ) { changeGridMode(); }
	}	
	// ̍쐬
	static char* strMenu[6] = { "GAME START", "START LEVEL", "MUSIC", "CAMERA", "GRID", "BACK" };
	static char strMusic[64];
	switch( music ) {
	case 0:	sprintf_s( strMusic, "MUSIC OFF" );	break;
	case 1:	sprintf_s( strMusic, "MUSIC A" );	break;
	case 2:	sprintf_s( strMusic, "MUSIC B" );	break;
	case 3:	sprintf_s( strMusic, "MUSIC C" );	break;
	}
	strMenu[2] = strMusic;
	if ( cameraMode == 1 ) { strMenu[3] = "CAMERA ON"; }
	else { strMenu[3] = "CAMERA OFF"; }
	if ( gridMode == 1 ) { strMenu[4] = "GRID ON"; }
	else { strMenu[4] = "GRID OFF"; }
	// `
	DrawGraph( 0, 0, grp.BG[1], false );
	DrawScore();
	DrawHold( 60.0f, 420.0f, 80.0f );
	DrawNext( 460.0f, 430.0f, 80.0f );
	DrawField( 200.0f, 430.0f, 80.0f );
	if ( cameraMode == 1 ) { DrawGraph( 0, 0, grp.CameraIcon, false ); }
	DrawMenu( 250, 120, 40, menu, strMenu );
}

// J[h̐؂ւ ---------------------------------------------------------------------- //
void changeCameraMode( void )
{	
	if ( cameraMode == 1 ) cameraMode = 0;
	else cameraMode = 1;
}

// Obh[h̐؂ւ -------------------------------------------------------------------- // 
void changeGridMode( void )
{
	if ( gridMode == 1 ) gridMode = 0;
	else gridMode = 1;
}

// CQ[ ---------------------------------------------------------------------------- //
void MainGame( void )	
{	
	// J̍W
	static VECTOR CameraPos = { 320.0f, 300.0f, -420.0f };
	if ( !cameraMode ) { CameraPos.x = 320.0f, CameraPos.y = 300.0f, CameraPos.z = -420.0f; }
	// s[Xڒn̗VтiŒ莞ԁj
	if ( fixTime > 0 ) fixTime--;
	if ( fixTime == 1 ) { 
		if ( !MoveDown() ) { FixPiece();
			if ( cameraMode ) {	CameraPos.x = 320.0f; CameraPos.y = 300.0f; }
		} else { fixTime = fixingTime; }
	}
	// R
	int f = 150 / level ;	// Xs[h
	if ( cameraMode ) { CameraPos.y -= 2.0f / f; }
	if ( frame % f == 0 ) {		
		if ( !MoveDown() ) { if ( fixTime == 0 ) fixTime = fixingTime; } 
	}
	// L[Fn[hhbv
	if( Key[KEY_INPUT_UP] == 1 ) { HardDrop(); 
		if ( cameraMode ) {	CameraPos.x = 320.0f; CameraPos.y = 300.0f; } 
	} 
	// L[F
	if( Key[KEY_INPUT_DOWN] != 0 &&  Key[KEY_INPUT_DOWN] < 1000 ) {	 
		if ( MoveDown() ) { CameraPos.y -= 0.1f; }
		else { 
			if ( fixTime == 0 ) fixTime = fixingTime;
			if ( fixTime >= 2 && fixTime <= fixingTime - 1 ) { // Œ莞Ԓ́L[Œ
				FixPiece(); 
				fixTime = 0;
				if ( cameraMode ) { CameraPos.x = 320.0f; CameraPos.y = 310.0f; }
			}
			Key[KEY_INPUT_DOWN] = 1000;		// ̃eg~mւ́L[̉e𐧌
		}
	}
	// L[FEړ
	if( Key[KEY_INPUT_LEFT] == 1 || Key[KEY_INPUT_LEFT] >= 30 ) {	
		if ( MoveLeft() ) { 
			if ( fixTime != 0 ) { fixTime = fixingTime; } 
			if ( cameraMode ) { CameraPos.x -= 15.0f; }
		}
	}
	else if( Key[KEY_INPUT_RIGHT] == 1 || Key[KEY_INPUT_RIGHT] >= 30 ) { 
		if ( MoveRight() ) { 
			if ( fixTime != 0 ) { fixTime = fixingTime; } 
			if ( cameraMode ) CameraPos.x += 15.0f; 
		} 
	}
	// XL[FE]
	if( Key[KEY_INPUT_X] == 1 ) {
		if ( TurnPiece( 1 ) ) { 
			PlaySoundMem( se.seTurn, DX_PLAYTYPE_BACK ); 
			if ( fixTime != 0 ) { fixTime = fixingTime; } 
		}
		else if ( TurnPiece( 0 ) ) { 
			PlaySoundMem( se.seTurn, DX_PLAYTYPE_BACK ); 
			if ( fixTime != 0 ) { fixTime = fixingTime; }
		}
	} 
	// ZL[F] 
	if( Key[KEY_INPUT_Z] == 1 ) {
		if ( TurnPiece( 0 ) ) {
			PlaySoundMem( se.seTurn, DX_PLAYTYPE_BACK ); 
			if ( fixTime != 0 ) { fixTime = fixingTime; } 
		} 
		else if ( TurnPiece( 1 ) ) { 
			PlaySoundMem( se.seTurn, DX_PLAYTYPE_BACK ); 
			if ( fixTime != 0 ) { fixTime = fixingTime; } 
		}
	} 
	// Xy[XL[Fz[h 
	if( Key[KEY_INPUT_SPACE] == 1 ) {	
		if ( HoldPiece() ) { 
			PlaySoundMem( se.seHold, DX_PLAYTYPE_NORMAL );
			score += level * getScore[5];
			if (score < 0) { score = 0; }
			fixTime = 0;
			if ( cameraMode ) {	CameraPos.x = 320.0f; CameraPos.y = 300.0f; }
		} 			
	} 
	// EnterL[F|[Y
	if( Key[KEY_INPUT_RETURN] == 1 ) { scene = _PAUSE;
		PlaySoundMem( se.seHold, DX_PLAYTYPE_NORMAL );		
	}
	// LShiftL[ : J
	if ( Key[KEY_INPUT_LSHIFT] == 1 ) {	changeCameraMode(); 
		PlaySoundMem( se.seHold, DX_PLAYTYPE_NORMAL ); 
	}
	// GL[ : Obh[h
	if ( Key[KEY_INPUT_G] == 1 ) {	changeGridMode(); 
		PlaySoundMem( se.seHold, DX_PLAYTYPE_NORMAL );
	}
	GhostBlock();	// S[XgubN̈ʒuvZ
	SetCameraPositionAndTarget_UpVecY( CameraPos, VGet( 320.0f, 240.0f, 1.0f ) );	// J̈ʒuƒ_ZbgA_͌_
	// `
	DrawGraph( 0, 0, grp.BG[1], false );
	DrawScore();
	DrawHold( 60.0f, 420.0f, 80.0f );
	DrawNext( 460.0f, 430.0f, 80.0f );
	DrawField( 200.0f, 430.0f, 80.0f );
	if ( cameraMode == 1 ) { DrawGraph( 0, 0, grp.CameraIcon, false ); }
}

// |[Y ---------------------------------------------------------------------------------- //
void Pause( void )
{
	if( Key[KEY_INPUT_RETURN] == 1 ) {
		PlaySoundMem( se.seHold, DX_PLAYTYPE_NORMAL );
		scene = _MAIN_GAME;
	}
	DrawGraph( 0, 0, grp.BG[1], false );
	DrawScore();
	if ( cameraMode == 1 ) { DrawGraph( 0, 0, grp.CameraIcon, false ); }
	DrawStringToHandle( 230, 160, "PAUSE", GetColor( 200, 200, 200 ), grp.font64 );
}

// GfBO ---------------------------------------------------------------------------- //
void Ending( void )
{
	static int time = 0;
	DrawGraph( 0, 0, grp.BG[0], false );
	int x = 100, y = 100, h = 60, t = 300;
	int color = GetColor( 200, 200, 200 );
	// `
	DrawStringToHandle( 460, 445, "Ru`J", color, grp.font20 );
	if ( time == 0 ) { time = frame; }
	if ( time + t*2 >  frame ) { 
		DrawStringToHandle( x, y, "/", color, grp.font24 );
		DrawStringToHandle( x, y+60, "@Yuichiro Itohara", color, grp.font24 );	
	}
	else if ( time + t*3 >  frame ) { DrawStringToHandle( x, y, "wifUC ", color, grp.font24 ); }
	else if ( time + t*4 >  frame ) { 
		DrawStringToHandle( x, y, "y AQUANOTE", color, grp.font24 ); 
		DrawStringToHandle( x, y+60, "ʉ ULTIMATEQ[ƕ", color, grp.font24 ); 
	}
	else if ( time + t*5 >  frame ) { 
		DrawStringToHandle( x, y, "XyVTNX", color, grp.font24 ); 
		DrawStringToHandle( x, y+60, "@DXCu Takumi Yamada", color, grp.font24 ); 
	}
	else if ( time + t*6 + 100 >  frame ) { DrawStringToHandle( x, y+100, "THANK YOU FOR YOUR PLAYING !!", color, grp.font24 ); }
	else { scene = _TITLE; time = 0; PlayMusicGame(); }
	// EnterL[FXLbv
	if( Key[KEY_INPUT_RETURN] == 1 ) { scene = _TITLE; time = 0; PlayMusicGame(); }	
}

// Q[I[o[ -------------------------------------------------------------------------- //
void GameOver( void )
{
	static int time = 0;
	if ( time == 0 ) { time = frame; }
	// ZL[
	if( Key[KEY_INPUT_Z] == 2 ) { time = 0;	scene = _TITLE; PlayMusicGame(); }
	DrawGraph( 0, 0, grp.BG[1], false );
	DrawStringToHandle( 160, 200, "GAME OVER", GetColor( 100, 100, 100 ), grp.font64 );
}

// s[X[𒲂ׂ ---------------------------------------------------------------------------- //
int GetTopSide( void )
{
	int length = 3;
	for( int y = 1 ; y >= 0 ; y-- ) { for( int x = 0 ; x < 5 ; x++ ) { if ( Piece[x][y] ) { length--; break; } } }
	return length;
}
int GetDownSide( void )
{
	int length = 3;
	for(int y = 3 ; y < 5 ; y++) { for(int x = 0 ; x < 5 ; x++) { if (Piece[x][y]) { length++; break; } } }
	return length;
}
int GetLeftSide( void )
{
	int length = 3;
	for(int x = 1 ; x >= 0 ; x--) {	for(int y = 0 ; y < 5 ; y++) { if (Piece[x][y]) { length--; break; } } }
	return length;
}
int GetRightSide( void )
{
	int length = 3;
	for(int x = 3 ; x < 5 ; x++) { for(int y = 0 ; y < 5 ; y++) { if (Piece[x][y]) { length++; break; } } }
	return length;
}

// s[X́ړ ------------------------------------------------------------------------------ //
bool MoveDown( void )
{
	int bottom = GetDownSide();
	if ( PieceY < ( FIELD_HEIGHT - bottom ) ) {
		int count = 0;
		for( int y = 0 ; y < 5 ; y++ ) { 
			for( int x = 0 ; x < 5 ; x++ ) {
				if ( Piece[x][y] && field[PieceX + x][PieceY + y + 1] ) { count++; }
			} 
		}
		if ( !count ) { PieceY++; }
		else { return false; }
	} else { return false; }
	return true;
}

// s[X́ړ ------------------------------------------------------------------------------ //
bool MoveLeft( void )
{	
	if ( PieceX > -( GetLeftSide() - 1 ) ) {
		int count = 0;
		for( int y = 0 ; y < 5 ; y++ ) { 
			for( int x = 0 ; x < 5 ; x++ ) {
				if ( Piece[x][y] && field[PieceX + x - 1][PieceY + y] ) { count++; }
			} 
		}
		if (!count) { PieceX--; }
		else { return false; }
	} else { return false; }
	return true;
}

// s[X́ړ ------------------------------------------------------------------------------ //
bool MoveRight( void )
{
	if ( PieceX < ( FIELD_WIDTH - GetRightSide() ) ) {
		int count = 0;
		for( int y = 0 ; y < 5 ; y++ ) { 
			for( int x = 0 ; x < 5 ; x++ ) {
				if (Piece[x][y] && field[PieceX + x + 1][PieceY + y]) { count++; }
			} 
		}
		if (!count) { PieceX++; }
		else { return false; }
	} else { return false; }
	return true;
}

// s[X̉] -------------------------------------------------------------------------------- //
// F0 ], 0ȊO E]
bool TurnPiece( int turn ) 
{	
	// ]s[X𐶐
	int turnPiece[5][5] = { 0 };
	int turnPieceX = PieceX, turnPieceY = PieceY;
	for( int y = 0 ; y < 5 ; y++ ) { 
		for( int x = 0 ; x < 5 ; x++ ) {
			if ( turn == 0 ) { turnPiece[y][4-x] = Piece[x][y]; }	// ] 
			else { turnPiece[4-y][x] = Piece[x][y]; }				// E]
		} 
	}
	// ]s[X̏Փ˔
	bool canTurn = true;		// 
	bool leftWall = false;		// ]s[Xǂɂ߂荞ł邩𒲂ׂtO
	bool rightWall = false;		// 
	bool bottomWall = false;	// 
	for( int y = 0 ; y < 5 ; y++ ) { 
		for( int x = 0 ; x < 5 ; x++ ) {
			if ( turnPiece[x][y] != 0 ) {
				int offsetX = turnPieceX + x, offsetY = turnPieceY + y;
				if ( offsetX < 0 ) { leftWall = true; }						// ǂƂ̏Փ
				if ( offsetX >= FIELD_WIDTH ) { rightWall = true; }			// EǂƂ̏Փ
				if ( offsetY >= FIELD_HEIGHT ) { bottomWall = true; }		// ǂƂ̏Փ
				if ( field[offsetX][offsetY] != 0 ) { bottomWall = true; }	// tB[h̃ubNƂ̏Փ
			}
		} 
	}
	// ǂƏՓ˂ꍇAʒu炷iX[p[[e[Vj
	if ( leftWall ) turnPieceX += 1;
	if ( rightWall ) turnPieceX -= 1;
	if ( bottomWall ) turnPieceY -= 1;
	// 炵ʒuł̏Փ˔
	if ( leftWall || rightWall || bottomWall ) {
		for( int y = 0 ; y < 5 ; y++ ) { 
			for( int x = 0 ; x < 5 ; x++ ) {
				if ( turnPiece[x][y] != 0 ) {
					int offsetX = turnPieceX + x, offsetY = turnPieceY + y;
					if ( offsetX < 0 || offsetX >= FIELD_WIDTH || offsetY >= FIELD_HEIGHT || field[offsetX][offsetY] != 0 ) { canTurn = false; }
				}
			} 
		}
	}
	// ݃s[X]s[X
	if ( canTurn ) {	
		memcpy( Piece, turnPiece , sizeof( int ) * 25 );
		PieceX = turnPieceX;
		PieceY = turnPieceY;
	}
	return canTurn;
}

// s[X̃z[h ---------------------------------------------------------------------------- //
int HoldPiece( void )
{	
	if ( holdFrag ) { return 0; }
	int copy[5][5] = {0} ;
	memcpy( copy, Piece , sizeof( int ) * 25 );
	memcpy( Piece, holdPiece , sizeof( int ) * 25 );
	memcpy( holdPiece, copy , sizeof( int ) * 25 );
	PieceX = 3;
	PieceY = -1;
	if ( Piece[2][2] == 0 ) { AppearPiece(); }
	holdFrag = true ;
	return 1;
}

// S[XgubN ---------------------------------------------------------------------------- //
void GhostBlock( void )
{	
	memcpy( ghostPiece, Piece , sizeof( int ) * 25 );
	ghostPieceX = PieceX;
	ghostPieceY = PieceY;	
	int bottom = GetDownSide();
	for ( int i=0; i< FIELD_HEIGHT; i++ ) {
		if ( ghostPieceY < ( FIELD_HEIGHT - bottom ) ) {
			int count = 0;
			for( int y = 0 ; y < 5 ; y++ ) { 
				for( int x = 0 ; x < 5 ; x++ ) {
					if ( ghostPiece[x][y] && field[ ghostPieceX + x ][ ghostPieceY + y + 1 ] ) { count++; }
				} 
			}
			if ( !count ) { ghostPieceY++; }
			else { break; }
		} else { break; }
	}
}

// n[hhbv ------------------------------------------------------------------------------ //
void HardDrop( void )
{		
	int bottom = GetDownSide();
	for ( int i=0; i< FIELD_HEIGHT; i++ ) {
		if ( PieceY < ( FIELD_HEIGHT - bottom ) ) {
			int count = 0;
			for( int y = 0 ; y < 5 ; y++ ) { 
				for( int x = 0 ; x < 5 ; x++ ) {
					if ( Piece[x][y] && field[ PieceX + x ][ PieceY + y + 1 ] ) { count++; }
				} 
			}
			if ( !count ) { PieceY++; }
			else { break; }
		} else { break; }
	}
	FixPiece();
}

// s[X̌Œ -------------------------------------------------------------------------------- //
void FixPiece( void ) 
{	
	PlaySoundMem( se.seSolid, DX_PLAYTYPE_NORMAL );
	for(int y = 0 ; y < 5 ; y++) { 
		for(int x = 0 ; x < 5 ; x++) {
			if (Piece[x][y] != 0) { field[PieceX + x][PieceY + y] = Piece[x][y]; }
		} 
	}
	// C
	int eraseLine = AdjustLine();
	if (eraseLine != 0) 
	{	
		PlaySoundMem( se.seErase, DX_PLAYTYPE_NORMAL );
		score += ( int )( level * ( getScore[eraseLine] + ( getScore[6] * chain ) ) );
		if ( score > bestScore ) bestScore = score;
		line += eraseLine;
		if ( level < line / 10 + 1 ) level = line / 10 + 1;
		if ( eraseLine == 4 ) chain++;
		else chain = 0;
	}
	AppearPiece();
	// Q[I
	if ( field[5][1] || ( PieceY + eraseLine + GetTopSide() - 1 ) < 0 ) 
	{	
		PlaySoundMem( se.seStart, DX_PLAYTYPE_BACK );
		if ( score < 100000 ) { scene = _GAME_OVER; PlayMusicGame(); } 
		else { scene = _ENDING; PlayMusicGame(); }
		for( int x=0; x<FIELD_WIDTH; x++ ) { for( int y=0; y<FIELD_HEIGHT; y++ ) { field[x][y] = 0;	} }					// tB[h̃NA
		for( int x=0; x<5; x++ ) { for( int y=0; y<5; y++ ) { Piece[x][y] = 0; holdPiece[x][y] = 0; } }					// s[XAz[h̃NA
		for( int i=0; i<3; i++ ) { for( int x=0; x<5; x++ ) { for( int y=0; y<5; y++ ) { nextPiece[i][x][y] = 0; } } }	// lNXg̃NA
		level = 1;
		line = 0;
		score = 0;
		chain = 0;
	}
}

// C ---------------------------------------------------------------------------------- //
int AdjustLine( void ) 
{	
	int delCount = 0;
	for(int y = FIELD_HEIGHT -1 ; y >= 0 ; ) {
		int lineCount = 0;
		for(int x = 0 ; x < FIELD_WIDTH ; x++) { if (field[x][y]) lineCount++; }
		if (lineCount == 0) break;	/*ɃubN͂Ȃ*/
		if (lineCount != FIELD_WIDTH) {	y--; continue; }
		/*s폜*/
		delCount++;
		for(int iy = y ; iy >= 0 ; iy--) {
			for(int x = 0 ; x < FIELD_WIDTH ; x++) {
				if (iy > 0) { field[x][iy] = field[x][iy - 1]; }
				else { field[x][0] = SH_NONE; }	/*0 s͂Ȃ̂ 0 Ŗ߂*/
			}
		}
	}
	return delCount;
}

// s[X̏o -------------------------------------------------------------------------------- //
void AppearPiece( void ) 
{	
	memcpy( Piece, nextPiece[0] , sizeof( int ) * 25 );
	memcpy( nextPiece[0], nextPiece[1] , sizeof( int ) * 25 );
	memcpy( nextPiece[1], nextPiece[2] , sizeof( int ) * 25 );
	// VɃs[X𐶐
	int piece[5][5] = { 0 };
	int num = GetRand(6) + 1;
	switch( num ) {
	case SH_I:		for (int i=1; i<5; ++i) { piece[i][2] = num; }	break;
	case SH_O:		piece[2][1] = num;	piece[2][2] = num;	piece[3][1] = num;	piece[3][2] = num;	break;
	case SH_S:		piece[1][2] = num;	piece[2][1] = num;	piece[2][2] = num;	piece[3][1] = num;	break;
	case SH_Z:		piece[1][1] = num;	piece[2][1] = num;	piece[2][2] = num;	piece[3][2] = num;	break;
	case SH_J:		piece[1][1] = num;	for (int i=1; i<4; ++i) { piece[i][2] = num; }	break;
	case SH_L:		piece[3][1] = num;	for (int i=1; i<4; ++i) { piece[i][2] = num; }	break;
	case SH_T:		piece[2][1] = num;	for (int i=1; i<4; ++i) { piece[i][2] = num; }	break;
	}
	memcpy( nextPiece[2], piece , sizeof( int ) * 25 );
	PieceX = 2;
	PieceY = -1;
	holdFrag = false ;
}

// `FXRA -------------------------------------------------------------------------------- //
void DrawScore( void )
{	
	int color[4][2] = {
		{ GetColor( 250, 150, 200 ), GetColor( 150, 50, 100 ) },
		{ GetColor( 250, 200, 200 ), GetColor( 150, 100, 100 ) },
		{ GetColor( 200, 150, 250 ), GetColor( 100, 50, 150 ) },
		{ GetColor( 200, 200, 250 ), GetColor( 100, 100, 150 ) }
	};
	int x = 40, y = 180, s = -2, h = 40;
	DrawFormatStringToHandle( x+s, y+s, color[2][0], grp.font24, "SCORE" );
	DrawFormatStringToHandle( x, y, color[2][1], grp.font24, "SCORE" );
	DrawFormatStringToHandle( x+s, y+s+30, color[2][0], grp.font24, " %d", score );
	DrawFormatStringToHandle( x, y+30, color[2][1], grp.font24, " %d", score );
	DrawFormatStringToHandle( x+s, y+s+h*2, color[3][0], grp.font24, "BEST" );
	DrawFormatStringToHandle( x, y+h*2, color[3][1], grp.font24, "BEST" );
	DrawFormatStringToHandle( x+s, y+s+h*2+30, color[3][0], grp.font24, " %d", bestScore );
	DrawFormatStringToHandle( x, y+h*2+30, color[3][1], grp.font24, " %d", bestScore );
	x = 40, y = 350, s = -2, h = 50;
	DrawFormatStringToHandle( x+s, y+s, color[1][0], grp.font24, "LINE %d", line );
	DrawFormatStringToHandle( x, y, color[1][1], grp.font24, "LINE %d", line );
	DrawFormatStringToHandle( x+s, y+s+h, color[0][0], grp.font24, "LEVEL %d", level );
	DrawFormatStringToHandle( x, y+h, color[0][1], grp.font24, "LEVEL %d", level );
	if ( chain != 0 ) {
		x = 460, y = 420, s = -2, h = 50;
		static int colorChain[2] = { GetColor( 200, 200, 200 ), 0 };
		if ( frame % 2 == 0 ) {	colorChain[1] = GetColor( GetRand(64) + 64, GetRand(64) + 64, GetRand(64) + 64 ); }
		DrawFormatStringToHandle( x+s, y+s, colorChain[0], grp.font24, "CHAIN %d", chain );
		DrawFormatStringToHandle( x, y, colorChain[1], grp.font24, "CHAIN %d", chain );
	}
}

// `Fz[h ------------------------------------------------------------------------------ //
void DrawHold( float X, float Y, float Z )
{	
	DrawStringToHandle( 100-2, 20-2, "HOLD", GetColor( 100, 100, 100 ), grp.font24 );
	DrawStringToHandle( 100, 20, "HOLD", GetColor( 180, 180, 180 ), grp.font24 );
	for ( int i=0; i<4; ++i ) {
		for( int y = 4; y >= 0 ; y-- ) {
			float X1 = X, Y1 = Y - ( y * PIECE_SIZE ), Z1 = Z ;
			for( int x = 0 ; x < 5 ; x++ ) {
				bool isPiece = holdPiece[x][y] != 0 ;
				//if ( i == 0 && gridMode == 1 ) { DrawPieceNone( SH_NONE, X1, Y1, Z1 ); }
				if ( i == 1 && isPiece ) { DrawPieceSide( holdPiece[x][y], X1, Y1, Z1 ); }
				if ( i == 2 && isPiece ) { DrawPieceTop( holdPiece[x][y], X1, Y1, Z1 ); }
				if ( i == 3 && isPiece ) { DrawPieceFront( holdPiece[x][y], X1, Y1, Z1 ); }
				X1 += PIECE_SIZE;
			}
		}
	} 
}

// `FlNXg ------------------------------------------------------------------------------ //
void DrawNext( float X, float Y, float Z )
{	
	DrawStringToHandle( 475-2, 20-2, "NEXT", GetColor( 100, 100, 100 ), grp.font24 );
	DrawStringToHandle( 475, 20, "NEXT", GetColor( 180, 180, 180 ), grp.font24 );
	for ( int j=0; j<3; ++j ) { 
		for ( int i=0; i<4; ++i ) {	for( int y = 4; y >= 0 ; y-- ) {
			float X1 = X, Y1 = Y - ( y * PIECE_SIZE ) - ( j * PIECE_SIZE * 5 ), Z1 = Z ;
			for( int x = 0 ; x < 5 ; x++ ) {
				bool isPiece = nextPiece[j][x][y] != 0 ;
				//if ( i == 0 && gridMode == 1 ) { DrawPieceNone( SH_NONE, X1, Y1, Z1); }
				if ( i == 1 && isPiece ) { DrawPieceSide( nextPiece[j][x][y], X1, Y1, Z1 ); }
				if ( i == 2 && isPiece ) { DrawPieceTop( nextPiece[j][x][y], X1, Y1, Z1 ); }
				if ( i == 3 && isPiece ) { DrawPieceFront( nextPiece[j][x][y], X1, Y1, Z1 ); }
				X1 += PIECE_SIZE;
			}
		} } 
	}
}

// `FtB[h ---------------------------------------------------------------------------- //
void DrawField( float X, float Y, float Z )	
{	
	// tB[hwi̕`
	if ( gridMode == 0 ) {
		int color = GetColor( 32, 32, 32 );
		int color2 = GetColor( GetRand(32) + 64, GetRand(32) + 64, GetRand(32) + 64 );
		float Xf = X, Yf = Y + PIECE_SIZE, Zf = Z + PIECE_SIZE;
		float Xf2 = X + PIECE_SIZE * FIELD_WIDTH, Yf2 = Yf - PIECE_SIZE * FIELD_HEIGHT ;
		DrawTriangle3D( VGet( Xf, Yf, Zf ), VGet( Xf2, Yf, Zf ), VGet( Xf, Yf2, Zf ), color, true );	// x^h
		DrawTriangle3D( VGet( Xf2, Yf2, Zf ), VGet( Xf2, Yf, Zf ), VGet( Xf, Yf2, Zf ), color, true );	// 
		DrawLine3D( VGet( Xf, Yf, Zf ), VGet( Xf2, Yf, Zf ), color2 );		// Og
		DrawLine3D( VGet( Xf, Yf, Zf ), VGet( Xf, Yf2, Zf ), color2 );		//
		DrawLine3D( VGet( Xf2, Yf, Zf ), VGet( Xf2, Yf2, Zf ), color2 );	//	
		DrawLine3D( VGet( Xf, Yf2, Zf ), VGet( Xf2, Yf2, Zf ), color2 );	//
	}
	// s[X̕`
	for (int i=0; i<4; ++i) {
		for(int y = 0 ; y <= FIELD_HEIGHT - 1 ; y++) {
			float X1 = X, Y1 = Y - y * PIECE_SIZE, Z1 = Z ;
			for(int x = 0 ; x < FIELD_WIDTH ; x++) {
				int px = x - PieceX, py = y - PieceY;
				bool isPiece = px >= 0 && px < 5 && py >= 0 && py < 5 && Piece[px][py] != 0 ;
				int gx = x - ghostPieceX, gy = y - ghostPieceY;
				bool isGhost = gx >= 0 && gx < 5 && gy >= 0 && gy < 5 && ghostPiece[gx][gy] != 0 ;
				if ( i == 0 && gridMode == 1 ) { DrawPieceNone( SH_NONE, X1, Y1, Z1 ); }
				if ( i == 0 && field[x][y] == 0 && isGhost ) { DrawPieceGhost( SH_NONE, X1, Y1, Z1 ); }
				if ( i == 1 && field[x][y] != 0 ) { DrawPieceSide( field[x][y], X1, Y1, Z1 ); }
				if ( i == 1 && field[x][y] == 0 && isPiece ) { DrawPieceSide( Piece[px][py], X1, Y1, Z1 ); }
				if ( i == 2 && field[x][y] != 0 ) { DrawPieceTop( field[x][y], X1, Y1, Z1 );  }
				if ( i == 2 && field[x][y] == 0 && isPiece ) { DrawPieceTop( Piece[px][py], X1, Y1, Z1 ); }
				if ( i == 3 && field[x][y] != 0 ) { DrawPieceFront( field[x][y], X1, Y1, Z1 );  }
				if ( i == 3 && field[x][y] == 0 && isPiece ) { DrawPieceFront( Piece[px][py], X1, Y1, Z1 ); }
				X1 += PIECE_SIZE;
			}
		}
	}
}

// `Fs[XFȂiObhj ------------------------------------------------------------ //
void DrawPieceNone( int piece, float X1, float Y1, float Z1 )
{	
	float X2 = X1 + PIECE_SIZE, Y2 = Y1 + PIECE_SIZE, Z2 = Z1 + PIECE_SIZE;
	int Color = 0 ;
	SetPieceColor( piece, Color, Color );
	DrawLine3D( VGet( X1, Y1, Z2 ), VGet( X2, Y1, Z2 ), Color );
	DrawLine3D( VGet( X2, Y1, Z2 ), VGet( X2, Y2, Z2 ), Color );
	DrawLine3D( VGet( X2, Y2, Z2 ), VGet( X1, Y2, Z2 ), Color );
	DrawLine3D( VGet( X1, Y2, Z2 ), VGet( X1, Y1, Z2 ), Color );
}

// `Fs[XFS[Xgiej ---------------------------------------------------------------- //
void DrawPieceGhost( int piece, float X1, float Y1, float Z1 )
{	
	float X2 = X1 + PIECE_SIZE, Y2 = Y1 + PIECE_SIZE, Z2 = Z1 + PIECE_SIZE;
	int Color = GetColor( 128, 128, 128 );
	DrawTriangle3D( VGet( X1, Y1, Z2 ), VGet( X1, Y2, Z2 ), VGet( X2, Y1, Z2 ), Color, true );
	DrawTriangle3D( VGet( X2, Y1, Z2 ), VGet( X1, Y2, Z2 ), VGet( X2, Y2, Z2 ), Color, true );
	DrawPieceNone( piece, X1, Y1, Z1 );
}

// `Fs[XF -------------------------------------------------------------------------- //
void DrawPieceSide( int piece, float X1, float Y1, float Z1 )
{	
	float X2 = X1 + PIECE_SIZE, Y2 = Y1 + PIECE_SIZE, Z2 = Z1 + PIECE_SIZE;
	int Color = 0, Color2 = 0;
	SetPieceColor( piece, Color, Color2 );
	// 
	DrawTriangle3D( VGet( X1, Y1, Z1 ), VGet( X1, Y2, Z1 ), VGet( X1, Y1, Z2 ), Color, true );
	DrawTriangle3D( VGet( X1, Y2, Z2 ), VGet( X1, Y2, Z1 ), VGet( X1, Y1, Z2 ), Color, true );
	// E
	DrawTriangle3D( VGet( X2, Y1, Z1 ), VGet( X2, Y2, Z1 ), VGet( X2, Y1, Z2 ), Color, true );
	DrawTriangle3D( VGet( X2, Y2, Z2 ), VGet( X2, Y2, Z1 ), VGet( X2, Y1, Z2 ), Color, true );		
}

// `Fs[XF -------------------------------------------------------------------------- //
void DrawPieceTop( int piece, float X1, float Y1, float Z1 )
{	
	float X2 = X1 + PIECE_SIZE, Y2 = Y1 + PIECE_SIZE, Z2 = Z1 + PIECE_SIZE;
	int Color = 0, Color2 = 0;
	SetPieceColor( piece, Color, Color2 );
	// 
	DrawTriangle3D( VGet( X1, Y1, Z1 ), VGet( X2, Y1, Z1 ), VGet( X1, Y1, Z2 ), Color, true );
	DrawTriangle3D( VGet( X2, Y1, Z2 ), VGet( X2, Y1, Z1 ), VGet( X1, Y1, Z2 ), Color, true );
	// 
	DrawTriangle3D( VGet( X1, Y2, Z1 ), VGet( X2, Y2, Z1 ), VGet( X1, Y2, Z2 ), Color, true );
	DrawTriangle3D( VGet( X2, Y2, Z2 ), VGet( X2, Y2, Z1 ), VGet( X1, Y2, Z2 ), Color, true );
	// ʂ̐
	DrawLine3D( VGet( X1, Y1, Z1 ), VGet( X1, Y1, Z2 ), Color2 );
	DrawLine3D( VGet( X2, Y1, Z1 ), VGet( X2, Y1, Z2 ), Color2 );
	DrawLine3D( VGet( X2, Y2, Z1 ), VGet( X2, Y2, Z2 ), Color2 );
	DrawLine3D( VGet( X1, Y2, Z1 ), VGet( X1, Y2, Z2 ), Color2 );
}

// `Fs[XFO -------------------------------------------------------------------------- //
void DrawPieceFront( int piece, float X1, float Y1, float Z1 )
{	
	float X2 = X1 + PIECE_SIZE, Y2 = Y1 + PIECE_SIZE, Z2 = Z1 + PIECE_SIZE;
	int Color = 0, Color2 = 0;
	SetPieceColor( piece, Color, Color2 );
	// O
	DrawTriangle3D( VGet( X1, Y1, Z1 ), VGet( X2, Y1, Z1 ), VGet( X1, Y2, Z1 ), Color, true );
	DrawTriangle3D( VGet( X2, Y2, Z1 ), VGet( X2, Y1, Z1 ), VGet( X1, Y2, Z1 ), Color, true );
	// Oʂ̐
	DrawLine3D( VGet( X1, Y1, Z1 ), VGet( X2, Y1, Z1 ), Color2 );
	DrawLine3D( VGet( X2, Y1, Z1 ), VGet( X2, Y2, Z1 ), Color2 );
	DrawLine3D( VGet( X2, Y2, Z1 ), VGet( X1, Y2, Z1 ), Color2 );
	DrawLine3D( VGet( X1, Y2, Z1 ), VGet( X1, Y1, Z1 ), Color2 );
}

// s[XF̐ݒ ------------------------------------------------------------------------------ //
void SetPieceColor( int piece, int& Color1, int& Color2 )
{	
	int a = 240;
	if (frame%16 == 0) { a = GetRand(32) + 220; }	// Ɍ点Fݒ
	switch( piece ) {
	case SH_NONE:	Color1 = GetColor( 100, 100, 100 );		Color2 = GetColor( 100, 100, 100 );		break ;
	case SH_I:		Color1 = GetColor( 100, a, a );			Color2 = GetColor( 50, 150, 150 );		break ;
	case SH_O:		Color1 = GetColor( a, a, 100 );			Color2 = GetColor( 150, 150, 50 );		break ;
	case SH_S:		Color1 = GetColor( 100, a, 100 );		Color2 = GetColor( 50, 150, 50 );		break ;
	case SH_Z:		Color1 = GetColor( a, 100, 100 );		Color2 = GetColor( 150, 50, 50 );		break ;
	case SH_J:		Color1 = GetColor( 100, 100, a );		Color2 = GetColor( 50, 50, 150 );		break ;
	case SH_L:		Color1 = GetColor( a, 150, 50 );		Color2 = GetColor( 150, 50, 50 );		break ;
	case SH_T:		Color1 = GetColor( a, 100, a );			Color2 = GetColor( 150, 50, 150 );		break ;
	}
}

// END OF FILE --------------------------------------------------------------------------------- //